account/urls.py
from django.urls import path, include
from . import views
from django.conf import settings
from django.conf.urls.static import static

app_name = 'account'

urlpatterns = [
    path('', views.profile, name='profile'),
    path('login/', views.login_view, name='login_view'),
    path('check/', views.check, name='check'),
    path('create_account/', views.create_account, name='create_account'),
    path('charge_account/<int:account_id>', views.charge_account, name='charge_account'),
    path('send_profile/<int:account_id>', views.send_profile, name='send_profile'),
    path('actions/', views.actions, name='actions'),
    path('change_chat_id/<int:profile_id>', views.change_chat_id, name='change_chat_id'),
]

api/urls.py
from django.urls import path
from . import views
from .views import MyTokenObtainPairView
from rest_framework.urlpatterns import format_suffix_patterns
from rest_framework_simplejwt.views import (
    TokenObtainPairView,
    TokenRefreshView,
)

app_name = 'api'

urlpatterns = [
    path('', views.getRoutes),
    path('token/', MyTokenObtainPairView.as_view(), name='token_obtain_pair'),
    path('token/refresh/', TokenRefreshView.as_view(), name='token_refresh'),
    path('home/', views.HomeView.as_view(), name='home'),
    path('profile/', views.profile_api, name='profile_api'),
    path('superadmin/', views.superadmin_api, name='superadmin_api'),
    path('account/create/', views.create_account_api, name='create_account_api'),
    path('account/charge/', views.charge_account_api, name='charge_account_api'),
]

urlpatterns = format_suffix_patterns(urlpatterns)

base/urls.py
from django.urls import path, include
from . import views
from django.conf import settings
from django.conf.urls.static import static

app_name = 'base'

urlpatterns = [
    path('', views.home, name='home'),
]

handler404 = views.error_404_view

blog/urls.py
from django.urls import path, include
from . import views
from django.conf import settings
from django.conf.urls.static import static

app_name = 'blog'

urlpatterns = [
    path('blog/<int:choice>', views.blog, name='blog'),
    path('post_detail/<int:id>/', views.post_detail, name='post_detail'),
]

ovpn/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.contrib.auth import views as auth_views
from django.conf.urls.static import static
from rest_framework_simplejwt import views as jwt_views
import os

urlpatterns = [
    path('', include('base.urls')),
    path('messages/', include('drf_messages.urls')),
    path('blog/', include('blog.urls')),
    path('account/', include('account.urls')),
    path('admin/', admin.site.urls),
    path('superadmin/', include('superadmin.urls')),
    path('logout/', auth_views.LogoutView.as_view(template_name='account/login.html'), name='logout'),
    path('api/', include('api.urls')),
    path('token/',
          jwt_views.TokenObtainPairView.as_view(),
          name ='token_obtain_pair'),
    path('token/refresh/',
          jwt_views.TokenRefreshView.as_view(),
          name ='token_refresh'),

]


if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

base/models.py
from django.db import models

# Create your models here.

blog/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone

STATUS = (
    (0,"News"),
    (1,"Documents"),
    (2,"Server news"),
    (3,"Final Destination"),
    (4,"Draft"),
)

class Post(models.Model):
    title = models.CharField(max_length = 200, unique = True)
    updated_on = models.DateTimeField(auto_now = True)
    content = models.TextField()
    created_on = models.DateTimeField(auto_now_add = True)
    status = models.IntegerField(choices = STATUS, default = 0)
    image = models.ImageField(default = None, upload_to = 'post_image', blank = True, null = True)
    file = models.FileField(upload_to = "files", blank = True, null = True, default = None)

    class Meta:
        ordering = ['-created_on']

    def __str__(self):
        return self.title

class Music(models.Model):
    name = models.CharField(max_length = 200)
    artist = models.CharField(max_length = 200, blank = True, null = True)
    image = models.ImageField(default = 'music.png', upload_to = 'post_image', blank = True, null = True)
    file = models.FileField(upload_to = "Music", default = None)
    lyrics = models.TextField(blank = True, null = True)

    def __str__(self):
        return self.name

class File(models.Model):
    name = models.CharField(max_length = 200, blank= True, null= True)
    file = models.FileField(upload_to = "File", default= None)

    def __str__(self):
        return self.name


class Image(models.Model):
    name = models.CharField(max_length = 200, blank= True, null= True)
    image = models.ImageField(upload_to = "Image", default= None)

base/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.http import HttpResponse, HttpResponseRedirect, FileResponse
from django.urls import reverse
from django.conf import settings
from django.core.files.storage import FileSystemStorage
from django.contrib import messages
from blog.models import Post, Music, Image, File
from django.template import Context, loader

def error_404_view(request, exception):

    # we add the path to the 404.html file
    # here. The name of our HTML file is 404.html
    return render(request, 'base/404.html')

def home(request):
    messages.add_message(request, messages.INFO, "hello to api messages")
    return render(request, 'base/home.html')

# Create your views here.

blog/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.http import HttpResponse, HttpResponseRedirect, FileResponse
from django.urls import reverse
from django.conf import settings
from django.core.files.storage import FileSystemStorage
from django.contrib import messages
from .models import Post, Music, Image, File

def home(request):
	context = {}
	try:
		post1 = get_object_or_404(Post, slug='start')
		post2 = get_object_or_404(Post, slug='pin')

		posts = [post1, post2]
		context = {'posts': posts}

	except Exception as e:
		pass
	
	musics = Music.objects.all()[:3]
	context.update({'musics': musics})

	return render(request, 'blog/home.html',context= context)

def profile(request):
	return render(request, 'blog/profile.html')

def files(request, choice):
	print(choice)
	if choice == 'all':
		musics = Music.objects.all()[:3]
		images = Image.objects.all()[:3]
		files = File.objects.all()[:5]

		context = {'images': images, 'musics': musics, 'files': files, 'choice': choice.capitalize()}
	
	elif choice == 'musics':
		musics = Music.objects.all()
		context = {'musics': musics, 'choice': choice.capitalize()}
	
	elif choice == 'images':
		images = Image.objects.all()
		context = {'images': images, 'choice': choice.capitalize()}

	elif choice == 'files':
		files = File.objects.all()
		context = {'files': files, 'choice': choice.capitalize()}
	
	return render(request, 'blog/files.html', context)

def blog(request, choice):
	if choice == 5:
		posts = Post.objects.all().order_by('-created_on')
	else:
		posts = Post.objects.filter(status=choice).order_by('-created_on')

	return render(request, 'blog/blog.html', context={'posts': posts, 'choice': choice})

def post_detail(request, id):
	post = get_object_or_404(Post)
	return render(request, 'blog/post_detail.html', context = {'post': post})




# Create your views here.

blog/templates/blog/base.html
<!doctype html>
{% load static %}
{% get_static_prefix as STATIC_PREFIX %}
<!DOCTYPE html>
<html data-bs-theme="light">
	<head>
			<meta HTTP-EQUIV="Content-Language" content="fa">
			<meta name="viewport" content="width=device-width, initial-scale=1">
	    <title>Final VPN</title>
			<link rel="icon" href="{% static 'base/fd.png' %}">
	    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
	</head>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-OERcA2EqjJCMA+/3y+gxIOqMEjwtxJY7qPCqsdltbNJuaOe923+mo//f6V8Qbsw3" crossorigin="anonymous">
	</script>

	<style>
	@font-face {
		font-family: vazir;
		font-style: normal;
		font-weight: 100;
		src: url("{% static 'base/iranyekanwebboldfanum.woff' %}") format("woff");
	}

		body {
		  font-family: ;
		}
	</style>

	<body>
	  <nav class="navbar navbar-expand-sm sticky-top bg-body-tertiary">
	    <div class="container-fluid">
	      <a class="navbar-brand" href="{% url 'base:home' %}">Final VPN</a>
	      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
	        <span class="navbar-toggler-icon"></span>
	      </button>
	      <div class="collapse navbar-collapse" id="navbarSupportedContent">
	        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
	      	  <li class="nav-item">
	      	    <a class="nav-link active" href="{% url 'blog:blog' 5 %}">Blog</a>
	      	  </li>

						{% if user.is_authenticated %}
							<li class="nav-item">
								<a class="nav-link" href="{% url 'account:profile' %}">Profile</a>
							</li>
							<li class="nav-item">
	        	    <a class="nav-link text-danger" href="{% url 'logout' %}">Log Out</a>
	        	  </li>
	          {% else %}
	          <li class="nav-item">
	            <a class="nav-link text-primary" href="{% url 'account:login_view' %}">Log in</a>
	          </li>
	          {% endif %}
	        </ul>
	      </div>
	    </div>
	  </nav>

	  <br>

	  <div class="container mt-3 mb-3">
	    {% block content %}
	    {% endblock %}
	  </div>


	</body>
	<script type="text/javascript">
  if (window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches) {
    document.documentElement.setAttribute('data-bs-theme','dark')
  }
  else {
    document.documentElement.setAttribute('data-bs-theme','light')
  }
  </script>
</html>

blog/templates/blog/blog.html
{% extends 'blog/base.html' %}

{% block content %}
<style type="text/css">
	@media only screen and (min-width: 768px) {
		.grid-right {
			width: 70%;
		}

		.grid-left {
			width: 30%;
			padding-right: 10px;
		}
	}

	@media only screen and (max-width: 768px) {
		.grid-right {
			width: 100%;
		}

		.grid-left {
			width: 100%;
		}
	}
</style>


	<div class="">
		<div class="float-start grid-left">
			<ul class="list-group mb-2">
				{% if choice == 5 %}
					<a href="{% url 'blog:blog' 5 %}" class="list-group-item active" aria-current="true">All posts</a>
				{% else %}
					<a href="{% url 'blog:blog' 5 %}" class="list-group-item " aria-current="true">All posts</a>
				{% endif %}

				{% if choice == 0 %}
					<a href="{% url 'blog:blog' 0 %}" class="list-group-item active" aria-current="true">News</a>
				{% else %}
					<a href="{% url 'blog:blog' 0 %}" class="list-group-item " aria-current="true">News</a>
				{% endif %}

				{% if choice == 1 %}
					<a href="{% url 'blog:blog' 1 %}" class="list-group-item active" aria-current="true">Documents</a>
				{% else %}
					<a href="{% url 'blog:blog' 1 %}" class="list-group-item " aria-current="true">Documents</a>
				{% endif %}

				{% if choice == 2 %}
					<a href="{% url 'blog:blog' 2 %}" class="list-group-item active" aria-current="true">Server news</a>
				{% else %}
					<a href="{% url 'blog:blog' 2 %}" class="list-group-item " aria-current="true">Server news</a>
				{% endif %}

				{% if choice == 3 %}
					<a href="{% url 'blog:blog' 3 %}" class="list-group-item active" aria-current="true">Final Destination</a>
				{% else %}
					<a href="{% url 'blog:blog' 3 %}" class="list-group-item " aria-current="true">Final Destination</a>
				{% endif %}
			</ul>

		</div>

		<div class="float-start grid-right">
		{% if posts %}
			{% for post in posts %}
				<div class="card rounded mb-2">
				  <div class="p-3" style="direction: rtl;" lang="fa">
				    <a style="text-decoration-line: none" href="{% url 'blog:post_detail' post.id  %}" data-bs-toggle="modal" data-bs-target="#exampleModal{{ post.id }}"><h5 class="text-end">{{ post.title }}</h5></a>
				    <p class="text-end">{{ post.content | slice:":500" }}</p>
				  </div>

					<!-- Modal -->
					<div class="modal fade" id="exampleModal{{ post.id }}" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
					  <div class="modal-dialog">
					    <div class="modal-content">
					      <div class="modal-header">
					        <h1 class="modal-title float-center fs-5" id="exampleModalLabel"><h5 class="text-center">{{ post.title }}</h5></h1>
					        <button type="button" class="btn-close float-end" data-bs-dismiss="modal" aria-label="Close"></button>
					      </div>
					      <div class="modal-body" style="direction: rtl;">
					        <div class="p-3">
							    <a style="text-decoration-line: none" href="{% url 'blog:post_detail' post.id  %}" ></a>
							    <p class="text-end">{{ post.content }}</p>
							  </div>
					      </div>
					      {% if post.file %}
						      <div class="modal-footer">
						      	<a style="text-decoration-line: none;" href="{{ post.file.url }}">{{ post.file.name }} <svg xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-folder" viewBox="0 0 16 16">
  <path d="M.54 3.87.5 3a2 2 0 0 1 2-2h3.672a2 2 0 0 1 1.414.586l.828.828A2 2 0 0 0 9.828 3h3.982a2 2 0 0 1 1.992 2.181l-.637 7A2 2 0 0 1 13.174 14H2.826a2 2 0 0 1-1.991-1.819l-.637-7a1.99 1.99 0 0 1 .342-1.31zM2.19 4a1 1 0 0 0-.996 1.09l.637 7a1 1 0 0 0 .995.91h10.348a1 1 0 0 0 .995-.91l.637-7A1 1 0 0 0 13.81 4H2.19zm4.69-1.707A1 1 0 0 0 6.172 2H2.5a1 1 0 0 0-1 .981l.006.139C1.72 3.042 1.95 3 2.19 3h5.396l-.707-.707z"/>
</svg></a></div>

						  {% endif %}
						  {% if post.image %}
						  	<img class="rounded mt-3" src="{{ post.image.url }}" width="100%" height="auto">

						  {% endif %}
					    </div>
					  </div>
					</div>

				  <div class="card-footer text-muted">
				  	تاریخ: {{ post.updated_on }}
				  </div>

				</div>
			{% endfor %}
		{% else %}
			<div class="alert alert-danger" role="alert">
			  There is no Posts yet!
			</div>
		{% endif %}
	</div>


	</div>
{% endblock %}

blog/templates/blog/post_detail.html
{% extends blog/base.html %}
{% block content %}
  <div class="m-3 p-1">
    <div class="row">
      <div class="col-md-12 card mb-4  mt-3 left top">
        <div class="card-body">

          <h1>{% block title %} {{ post.title }} {% endblock title %}</h1>
          <p class=" text-muted">{{ post.author }} | {{ post.created_on }}</p>

          <p class="card-text ">{{ post.content }}</p>
          <a style="text-decoration-line: none;" href="{{ post.file.url }}"><svg xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-folder" viewBox="0 0 16 16">
  <path d="M.54 3.87.5 3a2 2 0 0 1 2-2h3.672a2 2 0 0 1 1.414.586l.828.828A2 2 0 0 0 9.828 3h3.982a2 2 0 0 1 1.992 2.181l-.637 7A2 2 0 0 1 13.174 14H2.826a2 2 0 0 1-1.991-1.819l-.637-7a1.99 1.99 0 0 1 .342-1.31zM2.19 4a1 1 0 0 0-.996 1.09l.637 7a1 1 0 0 0 .995.91h10.348a1 1 0 0 0 .995-.91l.637-7A1 1 0 0 0 13.81 4H2.19zm4.69-1.707A1 1 0 0 0 6.172 2H2.5a1 1 0 0 0-1 .981l.006.139C1.72 3.042 1.95 3 2.19 3h5.396l-.707-.707z"/>
</svg> {{ post.file }}</a>
          <br>
          {% if post.image %}
            <img class="rounded mt-3" src="{{ post.image.url }}" width="100%" height="auto">
          {% endif %}
        </div>
      </div>
    </div>
  </div>
{% endblock %}